/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidMacroException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;

/**
 * This class contains a Macro that describes the attributes for the Ophthalmic Axial Measurements Quality Image SOP Instance Reference.
 * @author saloni
 *
 */
public class OphthalmicAxialMeasurementsQualityImageSOPInstanceReferenceMacro extends Macro  
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor constructs a Macro with specified Data Set.
	 * @param objDataSet Collection of Data Elements 
	 */
	public OphthalmicAxialMeasurementsQualityImageSOPInstanceReferenceMacro(IDataSet objDataSet)
	{
		super(objDataSet);
	}

	/**
	 * This constructor constructs a Macro with specified Data Set and Dictionary Reader
	 * @param objDataSet specifies the DataSet
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	public OphthalmicAxialMeasurementsQualityImageSOPInstanceReferenceMacro(IDataSet objDataSet,IDictionaryReader objDictionaryReader)
	{
		super(objDataSet,objDictionaryReader);
	}

	/**
	 * This constructor constructs a Macro with the specified Item
	 * @param objItem specifies instance of Item class
	 */
	public OphthalmicAxialMeasurementsQualityImageSOPInstanceReferenceMacro(IItem objItem)
	{
		super(objItem);
	}

	/**
	 * This constructor constructs a Macro with the specified Item and DictionaryReader
	 * @param objItem specifies instance of Item class
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	public OphthalmicAxialMeasurementsQualityImageSOPInstanceReferenceMacro(IItem objItem,IDictionaryReader objDictionaryReader)
	{
		super(objItem, objDictionaryReader);
	}

	/**
	 * Validates all the attributes in OphthalmicAxialLengthQualityMetricMacro
	 * @return boolean - Success -true, Failure -false.
	 * @throws InvalidMacroException throws InvalidMacroException If Mandatory or Conditional element fails.
	 */
	public boolean validate() throws InvalidMacroException
	{
		if(iMacroLevel == DicomConstants.DCM_MODULE_LEVEL_MACRO)
			return validate(objIDataSet);
		return false;
	}

	/**
	 * Validates all the attributes in OphthalmicAxialLengthQualityMetricMacro that are present in the DataSet
	 * @param objIDataSet collection of DataElements
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidMacroException throws InvalidMacroException If Mandatory or Conditional element fails.
	 */
	public boolean validate(IDataSet objIDataSet) throws InvalidMacroException
	{
		try{
			if(!objIDataSet.isPresent(0x0008,0x1150))
				throw new MandatoryMissingException("0008,1150");
			else if(!objIDataSet.isPresent(0x0008,0x1155))
				throw new MandatoryMissingException("0008,1155");
			else if(!objIDataSet.isPresent(0x0008,0x1160))
				throw new MandatoryMissingException("0008,1160");
			else
				((ReferencedSeriesSequence)objIDataSet.getDataForTag(0x0008,0x1115)).validate();
		}
		catch(MandatoryMissingException mme)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(mme.getMessage());
			}
			throw new InvalidMacroException(this.getClass().getSimpleName(),mme);
		}
		catch( ValidationException ve)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ve.getMessage());
			}
			throw new InvalidMacroException(this.getClass().getSimpleName(),ve);
		}
		return true;
	}
	/**
	 * Validates all the attributes in OphthalmicAxialLengthQualityMetricMacro that are present in the DataSet
	 * @param objIItem collection of DataElements in a sequence
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidMacroException throws InvalidMacroException If Mandatory or Conditional element fails.
	 */
	public static boolean validate(IItem objIItem) throws InvalidMacroException
	{
		try
		{  
			//validate condition here
			if(!objIItem.contains(0x0008,0x1150))
				throw new MandatoryMissingException("0008,1150");
			else if(!objIItem.contains(0x0008,0x1155))
				throw new MandatoryMissingException("0008,1155");
			else if(!objIItem.contains(0x0008,0x1160))
				throw new MandatoryMissingException("0008,1160");
		}
		catch( ConditionFailedException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new InvalidMacroException(OphthalmicAxialLengthQualityMetricMacro.class.getSimpleName(),ce); 
		}
		catch( MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new InvalidMacroException(OphthalmicAxialLengthQualityMetricMacro.class.getSimpleName(),me);
		}
		return true;
	}

	/**
	 * Sets a ReferencedSOPClassUIDinFile.
	 * @param strReferencedSOPClassUIDinFile String value of ReferencedSOPClassUIDinFile.
	 */
	public void setReferencedSOPClassUIDinFile(String strReferencedSOPClassUIDinFile)
	{
		/*Accept the ReferencedSOPClassUIDinFile in String format of type UI.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0008,0x1150, strReferencedSOPClassUIDinFile,objIDictionaryReader);
		else
			objIDataElement = new ExplicitDE(0x0008,0x1150,DicomConstants.DCM_DT_UI, strReferencedSOPClassUIDinFile);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves a ReferencedSOPClassUIDinFile.
	 * @return String - ReferencedSOPClassUIDinFile.
	 */
	public String getReferencedSOPClassUIDinFile()
	{
		Object objValue = getValue(0x0008,0x1150);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	

	/**
	 * Sets a ReferencedSOPInstanceUID.
	 * @param strReferencedSOPInstanceUID String value of ReferencedSOPInstanceUID.
	 */
	public void setReferencedSOPInstanceUID(String strReferencedSOPInstanceUID)
	{
		/*Accept the ReferencedSOPInstanceUID in String format of type UI.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0008,0x1155, strReferencedSOPInstanceUID,objIDictionaryReader);
		else
			objIDataElement = new ExplicitDE(0x0008,0x1155,DicomConstants.DCM_DT_UI, strReferencedSOPInstanceUID);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves ReferencedSOPInstanceUID.
	 * @return String - value of ReferencedSOPInstanceUID.
	 */
	public String getReferencedSOPInstanceUID()
	{
		Object objValue = getValue(0x0008,0x1155);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets Referenced Frame Number.
	 * @param strReferencedFrameNumber String value of Referenced Frame Number.
	 */
	public void setReferencedReferenceImageNumber (String strReferencedFrameNumber )
	{
		/*Accept the ReferencedFrameNumber  in String format of type IS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0008,0x1160, strReferencedFrameNumber ,objIDictionaryReader);
		else
			objIDataElement = new ExplicitDE(0x0008,0x1160,DicomConstants.DCM_DT_IS, strReferencedFrameNumber );

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves ReferencedFrameNumber.
	 * @return String - value of ReferencedFrameNumber.
	 */
	public String getReferencedFrameNumber()
	{
		Object objValue = getValue(0x0008,0x1160);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
}
